[gdk-pixbuf/ci-update: 2/2] ci: Add style check job




commit e29fb4650d4d1f4e5baf64dfb323d024845485fd
Author: Emmanuele Bassi <ebassi gnome org>
Date:   Mon Nov 9 14:34:52 2020 +0000

    ci: Add style check job
    
    Make at least an attempt at a consistent coding style.

 .clang-format                           | 11 +++++++++
 .gitlab-ci.yml                          | 13 ++++++++++
 .gitlab/scripts/run-style-check-diff.sh | 44 +++++++++++++++++++++++++++++++++
 3 files changed, 68 insertions(+)
---
diff --git a/.clang-format b/.clang-format
new file mode 100644
index 0000000000..13fd0fbd44
--- /dev/null
+++ b/.clang-format
@@ -0,0 +1,11 @@
+# See https://wiki.apertis.org/Guidelines/Coding_conventions#Code_formatting
+BasedOnStyle: GNU
+AlwaysBreakAfterDefinitionReturnType: All
+BreakBeforeBinaryOperators: None
+BinPackParameters: false
+SpaceAfterCStyleCast: true
+# Our column limit is actually 80, but setting that results in clang-format
+# making a lot of dubious hanging-indent choices; disable it and assume the
+# developer will line wrap appropriately. clang-format will still check
+# existing hanging indents.
+ColumnLimit: 0
diff --git a/.gitlab-ci.yml b/.gitlab-ci.yml
index fbe208a0dc..13cc8609ac 100644
--- a/.gitlab-ci.yml
+++ b/.gitlab-ci.yml
@@ -11,6 +11,11 @@ variables:
   MESON_TEST_TIMEOUT_MULTIPLIER: 3
   FEDORA_IMAGE: "registry.gitlab.gnome.org/gnome/gdk-pixbuf/fedora:v1"
 
+.only-default:
+  only:
+    - branches
+  except:
+    - tags
 
 .build-linux:
   before_script:
@@ -33,6 +38,14 @@ variables:
     paths:
       - _ccache/
 
+style-check-diff:
+  extends: .only-default
+  image: $FEDORA_IMAGE
+  stage: .pre
+  allow_failure: true
+  script:
+    - .gitlab/scripts/run-style-check-diff.sh
+
 meson-fedora-x86_64:
   stage: build
   extends: .build-linux
diff --git a/.gitlab/scripts/run-style-check-diff.sh b/.gitlab/scripts/run-style-check-diff.sh
new file mode 100755
index 0000000000..bfa9214636
--- /dev/null
+++ b/.gitlab/scripts/run-style-check-diff.sh
@@ -0,0 +1,44 @@
+#!/bin/bash
+
+set -e
+
+# We need to add a new remote for the upstream master, since this script could
+# be running in a personal fork of the repository which has out of date branches.
+if [ "${CI_PROJECT_NAMESPACE}" != "GNOME" ]; then
+    echo "Retrieving the current upstream repository from ${CI_PROJECT_NAMESPACE}/${CI_PROJECT_NAME}..."
+    git remote add upstream https://gitlab.gnome.org/GNOME/gdk-pixbuf.git
+    git fetch upstream
+    ORIGIN="upstream"
+else
+    echo "Reusing the existing repository on ${CI_PROJECT_NAMESPACE}/${CI_PROJECT_NAME}"
+    ORIGIN="origin"
+fi
+
+# Work out the newest common ancestor between the detached HEAD that this CI job
+# has checked out, and the upstream target branch (which will typically be
+# `upstream/master` or `upstream/gtk-3-24`).
+#
+# `${CI_MERGE_REQUEST_TARGET_BRANCH_NAME}` is only defined if we’re running in
+# a merge request pipeline; fall back to `${CI_DEFAULT_BRANCH}` otherwise.
+newest_common_ancestor_sha=$(diff --old-line-format='' --new-line-format='' <(git rev-list --first-parent 
"${ORIGIN}/${CI_MERGE_REQUEST_TARGET_BRANCH_NAME:-${CI_DEFAULT_BRANCH}}") <(git rev-list --first-parent HEAD) 
| head -1)
+git diff -U0 --no-color "${newest_common_ancestor_sha}" | .gitlab-ci/clang-format-diff.py -binary 
"clang-format" -p1
+exit_status=$?
+
+# The style check is not infallible. The clang-format configuration cannot
+# perfectly describe GTK’s coding style: in particular, it cannot align
+# function arguments. The documented coding style for GTK takes priority over
+# clang-format suggestions. Hopefully we can eventually improve clang-format to
+# be configurable enough for our coding style. That’s why this CI check is OK
+# to fail: the idea is that people can look through the output and ignore it if
+# it’s wrong. (That situation can also happen if someone touches pre-existing
+# badly formatted code and it doesn’t make sense to tidy up the wider coding
+# style with the changes they’re making.)
+echo ""
+echo "Note that clang-format output is advisory and cannot always match the"
+echo "GTK coding style, documented at:"
+echo "   https://gitlab.gnome.org/GNOME/gtk/blob/master/docs/CODING-STYLE";
+echo "Warnings from this tool can be ignored in favour of the documented "
+echo "coding style, or in favour of matching the style of existing"
+echo "surrounding code."
+
+exit ${exit_status}


[Date Prev][Date Next]   [Thread Prev][Thread Next]   [Thread Index] [Date Index] [Author Index]